// pac_i8014W_MagicScan_NonBlock.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>
#include <stdio.h>
#include <TCHAR.h>
#include <string.h>
#include <stdlib.h>
#include "..\Lib\pac_i8014W.h"
#pragma comment(lib,"..\\Lib\\pac_i8014W.lib")
int slotIndex=-1;
short jumper;
unsigned long TargetCnt=200000, totalSaved=0;
unsigned long T1,T2;
short chArr[16], gainArr[16], scanChCount;
float sampleRate,realsampleRate;
int scanMode, triggerSource, triggerState;
short hexData[204800];
unsigned long totalRead=0;
char GainStr[5][32]={"+/-10V","+/-5V","+/-2.5V","+/-1.25V","+/-20mA"};
char ModeStr[2][32]={"Standard Mode", "Sample and Hold Mode"};
char SourceStr[3][32]={"Software Command", "Internal Interrupt Signal","External Trigger Signal"};
char StateStr[2][32]={"High","Low"};
int runFlag=1;
int showCnt=0;
int selGain;
void ShowAI(void);
int maxCh=8;
int is14C =0;
int _tmain(int argc, _TCHAR* argv[])
{
	int slot,ch,c;
	short i,ret;
	short buffer[5000];
    char sTemp[20];
	short readcnt=0;
	short ReadCntFromFIFO=0;
    long left;
	unsigned short gainValue;
	short offsetValue;
	printf("\n\n This Demo will show how to use non-block mode magic scan function to read analog input\n\n");
	printf(" Search  I-8014W/I-8014CW/I-9014/I-9014C....\n");
	for(slot=0;slot<8;slot++)
	{
		if(pac_i8014W_Init(slot)==0) //find I-8014W module out
		{
			slotIndex=slot;
			break;
		}
	}
	if(slotIndex==-1)
	{
		printf("\t There is no I-8014W/I-8014CW/I-9014/I-9014C at Backplane\n");
		Sleep(100);
		exit(0);
	}
	else
	{
		printf("\t There is an  I-8014W/I-8014CW/I-9014/I-9014C at slot %d\n",slotIndex);
	}
	printf("Input 0, if module is I-8014W/I-9014 \n");
	printf("Input 1, if module is I-8014CW/I-9014C \n");
	scanf("%d", &is14C);
	if(is14C==0)
	{
		jumper= pac_i8014W_GetSingleEndJumper(slotIndex);
		if(jumper)
		{
			maxCh=16;
			printf("\t  Input Mode=Single-End and can have maximum 16 analog input\n\r");
		}
		else
		{
    		maxCh=8;
			printf("\t  Input Mode=Differential and can have maximum 8 analog input\n\r");
		}
	}
	else
	{
		maxCh=8;
	}
	// define the sampling channels array chArr[]
	// Differential Mode: element for chArr[] range from channel 0 ~ 7 ,
	// Single ended Mode: element for chArr[] range from channel 0 ~ 15
	// max element counts for chArr[] can be 16
	// define gain type array for each channel
	// gainArr[] element for gainArr[] range from channel 0 ~ 15
	// Gain value : 0="+/-10V",1="+/-5V",2="+/-2.5V",3="+/-1.25V",4="+/-20mA"
	// max element counts for gainArr[] can be 16
start:
	printf ("\n\n Input all the parameters to configure the MagicScan  :\n\r");
	// assigned channel count
    printf("\n Step 1: Define scanned channel counts for magic scan:");
	printf("\n Input scanned channel counts (1~%d) :", maxCh);
	scanf("%d",&scanChCount);
    printf("Scanned channel counts = %d\n\n",scanChCount);
	// assing input range (gain)
	printf("\n Step 2: Define input range (gain)");
    printf("\n The Gain definition");
	for(i=0;i<5;i++)
    {
    	printf ("\n\t Select %d :  %s",i,GainStr[i]);
    }
    printf("\n\r");
	printf (" Select which Gain of (0~4):");
	scanf("%d", &selGain);
    for(i=0;i<scanChCount;i++)
    {
    	chArr[i]=i;
    	gainArr[i]=selGain;
    }
	//pac_i8014W_ReadGainOffset(slotIndex,selGain,&gainValue, &offsetValue);
	// assign Sample rate
	printf("\n\n Step 3: Define Sample Rate of \n");
    // Sample rate : 1 ~ 250KHz
    printf (" Input Sample rate  (1~2500000) :");
    scanf("%f",&sampleRate);
    printf(" Note: the real sample rate may not the same as user input");
	printf("\n the function pac_i8014W_ConfigMagicScan return code is the real sample rate \n");
    // assign scan mode
    // Scan Mode = 1 M1 standard mode, Each Sample clock only samples a single channel
    // Scan Mode = 2 M2 Sample and hold Mode
    printf ("\n\n Step 4:Select Scan Mode :\n");
    printf ("\t Scan Mode 1= M1 Standart Mode \n\t Scan Mode 2= M2 Sample and Hold Mode \n\r");
    printf (" Input Scan Mode (1 or 2) :");
    scanf("%d", &scanMode);
    // assign trigger source
    // trigger source 0, start magic scan via polling Mode, software command can only trigger one slot I-8014
    // trigger source 1, start magic scan via internal interrupt signal Mode, internal interrupt signal can trigger all I-8014Ws on slots at the same time.
    // trigger source 2, start magic scan via external trigger signal Mode, extern trigger can also trigger all I-8014Ws on slots at the same time.
    printf ("\n\n Step 5: Select Trigger Source can have 3 types of trigger source \n");
    printf ("\t trigger source 0= Software Command \n\t trigger source 1= Internal Interrupt Signal \n\t trigger source 2= External Tigger Signal\n\r");
    printf (" Input trigger source (0~2) :");
    scanf("%d",&triggerSource);
    // assign external trigger state
    // triggerState only related with external DI trigger signal.
    // if triggerState 0, external DI trigger signal must be high to start magic scan (default)
    // if triggerState 1, external DI trigger signal must be low to start magic scan
    printf ("\n\n Step6: Select Trigger State if select external trigger source ( 2 ).\n");
    if(triggerSource==2)
    {
	    printf ("\t trigger State 0= external trigger singal high to start magic scan \n\t trigger State 1= external trigger signal low to start magic scan\n\r");
	    printf (" Input trigger State  (0 or 1) :");
	    scanf("%d",&triggerState);
	}
	else
	{
		printf ("\t Not external trigger source, trigger state =0 \n");
		triggerState=0;
	}
    printf ("\n\n Step 6: Select Read Count \n");
	printf("-----------------------------------------\n");
	printf("| total sample rate | default read count |\n");
	printf("-----------------------------------------\n");
	printf("|      <1000        |        8           |\n");
	printf("-----------------------------------------\n");
	printf("|    >1000,<4000    |        16          |\n");
	printf("-----------------------------------------\n");
	printf("|    >4000,<10000   |        32          |\n");
	printf("-----------------------------------------\n");
	printf("|    >10000,<12000  |        64          |\n");
	printf("-----------------------------------------\n");
	printf("|    >12000,<20000  |        128         |\n");
	printf("-----------------------------------------\n");
	printf("|    >20000,<32000  |        256         |\n");
	printf("-----------------------------------------\n");
	printf("|    >32000,<40000  |        512         |\n");
	printf("-----------------------------------------\n");
	printf("|      >40000       |        2048        |\n");
	printf("-----------------------------------------\n");
    printf (" Input trigger source (1~4096) :");
    scanf("%d",&readcnt);
    // When Configure Sample Rate of Magic Scan, the result sample rate may be different from input sample rate
    // Note i8014W_ConfigMagicScan only tell I-8014W how to start magic scan,it will not start magic scan
    // We have to call i8014W_StartMagicScan to start up the magic scan.
	pac_i8014W_ConfigMagicScan(slotIndex,chArr,gainArr,scanChCount, sampleRate, scanMode,triggerSource,triggerState, &realsampleRate);
	printf("\n\nThe Magic Scan Configurations of I-8014W/I-9014 are:\n");
	printf("\t Scan channel count = %d\n", scanChCount);
	for(i=0;i<scanChCount;i++)
	{
		printf("\t CH[%d]= %d\t Gain[%d]= %d ( %s )\n",i, chArr[i],i, gainArr[i], GainStr[gainArr[i]]);
	}
	printf("\t Scan Mode = %d ( %s )\n", scanMode, ModeStr[scanMode-1]);
	printf("\t Trigger Source = %d ( %s )\n", triggerSource, SourceStr[triggerSource]);
	if(triggerSource==2)
		printf("\t Trigger State = %d ( %s )\n", triggerState, StateStr[triggerState]);
	else
		printf("\t Trigger State = %d ( No need for External Trigger Signal )\n", triggerState);
	printf("\t Set Sample Rate = %6.3f  Real Sample Rate = %6.3f \n",sampleRate, realsampleRate);
	//Send external trigger for I-8014W module
	if(triggerSource==2)
	{
		printf("Wait for external trigger signal source to %s .....\n", StateStr[triggerState]);
	}
	else
	{
		printf("Press any key to start Magic Scan\n");
		getchar();
		Sleep(100);
	}
	totalSaved=0;
	totalRead=0;
	pac_i8014W_StartMagicScan(slotIndex);
	T1=GetTickCount();
	runFlag=1;
	while (runFlag==1)
	{
		ret= pac_i8014W_ReadFIFO(slotIndex,buffer, readcnt ,&ReadCntFromFIFO);// <=== get data from FIFO ,long* dataCnt
		if(ret==FIFO_LATCHED)
		{
			pac_i8014W_StopMagicScan(slotIndex);
			printf("\nStop magic scan and FIFO data amount = %lu, saved %lu\n", totalRead,totalSaved);
			runFlag=0;
		}
		else
		{
			if(ReadCntFromFIFO>0)
			{
				if(ReadCntFromFIFO + totalRead > TargetCnt)
				{
					left = TargetCnt- totalRead;
					memcpy(hexData + totalRead, buffer, sizeof(short)*(left));
					totalSaved+=left;
					totalRead+=ReadCntFromFIFO;
					pac_i8014W_StopMagicScan(slotIndex);
					runFlag=0;
					printf("\nret = [%d] S_ %lu, T_ %lu, R_ %d L_ %ld \n",ret,totalSaved,totalRead,ReadCntFromFIFO,left);
				}
				else
				{
					memcpy(hexData + totalRead, buffer, sizeof(short)*(ReadCntFromFIFO));
					totalSaved+=ReadCntFromFIFO;
					totalRead+=ReadCntFromFIFO;
				}
				if(GetTickCount()- T1 >=5000)
				{
					printf("S_%lu / T_200000 \r",totalRead);
					T1=GetTickCount();
				}
			}
		}
		Sleep(1);
	}
	T2=GetTickCount()-T1; // total time for magic scan to polling data
	printf("Magic scan total spend time = %lu ms  \n\n\n",T2);
	printf("Input 0 to Show AI\n");
	scanf("%s",sTemp);
	ShowAI();
    printf("Input '0' to quit program\n");
	printf("Input 1 to start again\n");
	scanf("%s",sTemp);
	i=atoi(sTemp);
 	if ((i==0))
 		return 0;
 	else
 		goto start;
}
void ShowAI(void)
{
	unsigned long i;
	float calibratedAI=0;
	printf("Start to printf all data:\n\n\r");
	for(i=0;i<totalRead;i++)
	{
		if(i%(scanChCount*100)==0)
		{
			printf("Press any key to check next 100 data\n");
			getchar();
		}
		if(is14C==0)
		{
			pac_i8014W_CalibrateData(slotIndex, gainArr[i %scanChCount] ,hexData[i],&calibratedAI);
		}
		else
		{
			pac_i8014W_Calibrate_CH_mA(slotIndex, i %scanChCount ,hexData[i],&calibratedAI);
		}
		if(i%scanChCount==scanChCount-1)
			printf("%d_%6.3f \n",i%scanChCount,calibratedAI);
		else
			printf("%d_%6.3f ",i%scanChCount,calibratedAI);
	}
	printf("\n---------\n");
}