﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace pac_i8028UW_Basic_Info
{
    public partial class Form1 : Form
    {
        int slot = 0;
        short FarmVer = 0;
        short LibVer = 0;
        string LibDate = "";
        int ch = -1;
        short range = -1;
        ushort gain;
        short offset;

        private string[] RangeStr = new string[6];
        private string[] SlotStr = new string[9];
        private string[] ChStr = new string[8];

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Description_list.Items.Add("This demo tells the Analog Output function.");
            Description_list.Items.Add("Please follow the below steps.");
            Description_list.Items.Add("1. Select slot");

            RangeStr[0] = "0 ~ 5V";
            RangeStr[1] = "0 ~ 10V";
            RangeStr[2] = "+/- 5V";
            RangeStr[3] = "+/- 10V";
            RangeStr[4] = "4 ~ 20mA";
            RangeStr[5] = "0 ~ 20mA";

            SlotStr[0] = "Slot 0";
            SlotStr[1] = "Slot 1";
            SlotStr[2] = "Slot 2";
            SlotStr[3] = "Slot 3";
            SlotStr[4] = "Slot 4";
            SlotStr[5] = "Slot 5";
            SlotStr[6] = "Slot 6";
            SlotStr[7] = "Slot 7";
            SlotStr[8] = "Auto Search";

            ChStr[0] = "Channel 0";
            ChStr[1] = "Channel 1";
            ChStr[2] = "Channel 2";
            ChStr[3] = "Channel 3";
            ChStr[4] = "Channel 4";
            ChStr[5] = "Channel 5";
            ChStr[6] = "Channel 6";
            ChStr[7] = "Channel 7";

            for (int i = 0; i < 6; i++)
            {
                Range_cbo.Items.Add(RangeStr[i]);
            }
            for (int i = 0; i < 9; i++)
            {
                SlotIndex_cbo.Items.Add(SlotStr[i]);
            }
            for (int i = 0; i < 8; i++)
            {
                Ch_cbo.Items.Add(ChStr[i]);
            }
            LibVer = pac_i8028UNet.pac8028U.LibVersion();
            LibVer_txt.Text = LibVer.ToString("X");
            LibDate = pac_i8028UNet.pac8028U.LibDate();
            LibDate_txt.Text = LibDate;
        }

        private void SlotIndex_cbo_SelectedIndexChanged(object sender, EventArgs e)
        {
            int ret = 0;
            int i = 0;
            string msg = "";
            slot = SlotIndex_cbo.SelectedIndex;
            if (slot == 8)
            {
                for (i = 0; i < 8; i++)
                {
                    ret = pac_i8028UNet.pac8028U.Init(i);
                    if (ret == 0)
                    {
                        slot = i;
                        msg = string.Format("Find Module on slot {0}", slot);
                        MessageBox.Show(msg);
                        break;
                    }
                }
                if (slot == 8)
                {
                    MessageBox.Show("Cmt not find Module");
                    return;
                }
            }
            else
            {
                ret = pac_i8028UNet.pac8028U.Init(slot);
                if (ret != 0)
                {
                    MessageBox.Show("Cmt not find Module");
                    return;
                }
            }
            pac_i8028UNet.pac8028U.FirmwareVersion(slot, ref FarmVer);
            FirmVer_txt.Text = FarmVer.ToString();
            Description_list.Items.Add("2. Select channel");
        }

        private void Ch_cbo_SelectedIndexChanged(object sender, EventArgs e)
        {
            ch = Ch_cbo.SelectedIndex;
            if (range != -1)
            {
                UpdataGainOffset();
            }
            Description_list.Items.Add("3. Select range");
        }

        private void Range_cbo_SelectedIndexChanged(object sender, EventArgs e)
        {
            range = (short)Range_cbo.SelectedIndex;
            if (ch != -1)
            {
                UpdataGainOffset();
            }
            Description_list.Items.Add("4. Input Output value and");
            Description_list.Items.Add("click 'AO Output' button");
        }

        void UpdataGainOffset()
        {
            pac_i8028UNet.pac8028U.ReadGainOffset(slot, ch, range, ref gain, ref offset);
            Gain_txt.Text = Convert.ToString(gain);
            Offset_txt.Text = Convert.ToString(offset);
        }

        private void btnAO_Click(object sender, EventArgs e)
        {
            float ao = 0;
            ao = float.Parse(AO_txt.Text);
            pac_i8028UNet.pac8028U.WriteAO(slot, ch, range, ao);
            Description_list.Items.Add("Now, the output should change");
            Description_list.Items.Add("to 'Output Value'.");
        }

        private void btnExit_Click(object sender, EventArgs e)
        {
            Close();
        }
    }
}